# TODO:
# - fix build without libxml2-devel (python library uses old headers)
#
# Conditional build:
%bcond_without	apidocs		# do not build and package API docs
%bcond_without	python		# don't build python module
%bcond_without	static_libs	# don't build static libraries
%bcond_without	zlib		# don't use zlib
%bcond_with	mem_debug	# enable libxml2 memory debuging

Summary:	libXML library
Summary(es.UTF-8):	Biblioteca libXML version 2
Summary(pl.UTF-8):	Biblioteka libXML wersja 2
Summary(pt_BR.UTF-8):	Biblioteca libXML versão 2
Name:		libxml2
Version:	2.8.0
Release:	2
Epoch:		1
License:	MIT
Group:		Libraries
#Source0:	http://ftp.gnome.org/pub/GNOME/sources/libxml2/2.6/%{name}-%{version}.tar.bz2
Source0:	ftp://xmlsoft.org/libxml2/%{name}-%{version}.tar.gz
# Source0-md5:	c62106f02ee00b6437f0fb9d370c1093
Patch0:		%{name}-man_fixes.patch
Patch1:		%{name}-open.gz.patch
Patch2:		%{name}-largefile.patch
Patch3:		%{name}-CVE-2012-2807.patch
URL:		http://xmlsoft.org/
BuildRequires:	autoconf >= 2.59
BuildRequires:	automake >= 1.4
BuildRequires:	libtool >= 1:1.4.2-9
%{?with_python:BuildRequires:	python-devel}
%{?with_python:BuildRequires:	python-modules}
%{?with_python:BuildRequires:	rpm-pythonprov}
BuildRequires:	rpmbuild(macros) >= 1.219
%{?with_zlib:BuildRequires:	zlib-devel >= 1.2.3.3}
# history support in xmllint is disabled by default
#BuildRequires:	ncurses-devel
#BuildRequires:	readline-devel >= 4.2
Requires:	zlib >= 1.2.3.3
Obsoletes:	xml-common
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This library allows you to manipulate XML files.

%description -l es.UTF-8
Esta biblioteca permite manipulación de archivos XML.

%description -l pl.UTF-8
Biblioteka libxml2 umożliwia manipulowanie zawartością plików XML.

%description -l pt_BR.UTF-8
Esta biblioteca permite a manipulação de arquivos XML.

%package devel
Summary:	Header files etc to develop libxml2 applications
Summary(es.UTF-8):	Biblioteca y archivos de inclusión para desarrollo de aplicaciones libXML
Summary(pl.UTF-8):	Pliki nagłówkowe i inne do libxml2
Summary(pt_BR.UTF-8):	Bibliotecas e arquivos de inclusão para desenvolvimento de aplicações que usem a biblioteca libxml
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	zlib-devel

%description devel
Header files etc you can use to develop libxml2 applications.

%description devel -l es.UTF-8
Biblioteca y archivos de inclusión para desarrollo de aplicaciones
libXML.

%description devel -l pl.UTF-8
Pakiet ten zawiera pliki nagłówkowe i inne do libxml2 niezbędne przy
tworzeniu aplikacji opartych o tę bibliotekę.

%description devel -l pt_BR.UTF-8
Bibliotecas e arquivos de inclusão para desenvolvimento de aplicações
que usem a biblioteca libxml.

%package static
Summary:	Static libxml2 libraries
Summary(es.UTF-8):	Static libraries to develop libxml applications
Summary(pl.UTF-8):	Biblioteka statyczna libxml2
Summary(pt_BR.UTF-8):	Bibliotecas estáticas para desenvolvimento de aplicações que usem a biblioteca libxml
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}

%description static
Static libxml2 libraries.

%description static -l es.UTF-8
Static libraries, you can use to develop libxml applications.

%description static -l pl.UTF-8
Biblioteka statyczna libxml2.

%description static -l pt_BR.UTF-8
Bibliotecas estáticas para desenvolvimento de aplicações que usem a
biblioteca libxml.

%package apidocs
Summary:	libxml2 API documentation
Summary(pl.UTF-8):	Dokumentacja API libxml2
Group:		Documentation
Requires:	gtk-doc-common

%description apidocs
libxml2 API documentation.

%description apidocs -l pl.UTF-8
Dokumentacja API libxml2.

%package progs
Summary:	XML files parser
Summary(pl.UTF-8):	Analizator składniowy plików XML
Group:		Applications/Text
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description progs
XML files parser.

%description progs -l pl.UTF-8
Analizator składniowy plików XML.

%package -n python-%{name}
Summary:	Python support for libxml2
Summary(pl.UTF-8):	Moduły języka Python dla biblioteki libxml2
Group:		Libraries/Python
Requires:	%{name} = %{epoch}:%{version}-%{release}
%pyrequires_eq	python-libs
Obsoletes:	libxml2-python

%description -n python-%{name}
Python support for libxml2.

%description -n python-%{name} -l pl.UTF-8
Moduły języka Python dla biblioteki libxml2.

%prep
%setup -q
%patch0 -p1
%if %{with zlib}
%patch1 -p1
%endif
%patch2 -p1
%patch3 -p1

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--disable-silent-rules \
	%{!?with_static_libs:--disable-static=no} \
	%{!?with_python:--without-python} \
	%{!?with_zlib:--without-zlib} \
	--with%{!?with_mem_debug:out}-mem-debug

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	DEVHELP_DIR=%{_gtkdocdir}/libxml2 \
	m4datadir=%{_aclocaldir} \
	pkgconfigdir=%{_pkgconfigdir}

# move examples to proper dir
install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-devel-%{version} \
	$RPM_BUILD_ROOT%{_examplesdir}/python-%{name}-%{version}
mv $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/examples/* \
	$RPM_BUILD_ROOT%{_examplesdir}/%{name}-devel-%{version}

%if %{with python}
mv -f $RPM_BUILD_ROOT%{_docdir}/%{name}-python-%{version}/examples/* \
	$RPM_BUILD_ROOT%{_examplesdir}/python-%{name}-%{version}

%if "%{py_ver}" > "2.4"
cd python
./setup.py install_egg_info --install-dir=$RPM_BUILD_ROOT%{py_sitedir}
cd ..
%endif
%endif

# move html doc to -devel package
install -d $RPM_BUILD_ROOT%{_docdir}/%{name}-devel-%{version}
mv -f $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/html \
	$RPM_BUILD_ROOT%{_docdir}/%{name}-devel-%{version}
rm -rf $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# install catalog file
install -d $RPM_BUILD_ROOT%{_sysconfdir}/xml
LD_LIBRARY_PATH=.libs ./xmlcatalog --create \
	> $RPM_BUILD_ROOT%{_sysconfdir}/xml/catalog

%if %{with python}
%py_ocomp $RPM_BUILD_ROOT%{py_sitedir}
%py_comp $RPM_BUILD_ROOT%{py_sitedir}
%py_postclean
rm -f $RPM_BUILD_ROOT%{py_sitedir}/*.{la,a}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog Copyright NEWS README TODO
%attr(755,root,root) %{_libdir}/libxml2.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libxml2.so.2
%{_mandir}/man3/libxml.3*

%dir %{_sysconfdir}/xml
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/xml/catalog

%files devel
%defattr(644,root,root,755)
%doc %{_docdir}/%{name}-devel-%{version}
%attr(755,root,root) %{_bindir}/xml2-config
%attr(755,root,root) %{_libdir}/libxml2.so
%{_libdir}/libxml2.la
%attr(755,root,root) %{_libdir}/xml2Conf.sh
%{_pkgconfigdir}/libxml-2.0.pc
%{_aclocaldir}/libxml.m4
%{_includedir}/libxml2
%{_mandir}/man1/xml2-config.1*
%{_examplesdir}/%{name}-devel-%{version}

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libxml2.a
%endif

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%{_gtkdocdir}/libxml2
%endif

%files progs
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/xmlcatalog
%attr(755,root,root) %{_bindir}/xmllint
%{_mandir}/man1/xmlcatalog.1*
%{_mandir}/man1/xmllint.1*

%if %{with python}
%files -n python-%{name}
%defattr(644,root,root,755)
%attr(755,root,root) %{py_sitedir}/libxml2mod.so
%{py_sitedir}/drv_libxml2.py[co]
%{py_sitedir}/libxml2.py[co]
%if "%{py_ver}" > "2.4"
%{py_sitedir}/libxml2_python-*.egg-info
%endif
%{_examplesdir}/python-%{name}-%{version}
%endif
%changelog
* Mon Aug 06 2012 Kacper Kornet <draenog@pld-linux.org> a893934
- fixes for some integer overflows (CVE-2012-2807)

* Thu May 24 2012 Jakub Bogusz <qboosh@pld-linux.org> 7497155
- updated to 2.8.0
- removed obsolete amfix,version-script,XPath patches

* Mon Jun 06 2011 marti <marti@pld-linux.org> 10b29e3
- security patch: Invalid XPath Multiple Memory Corruption
- http://git.gnome.org/browse/libxml2/commit/?id=d7958b21e7f8c447a26bb2436f08402b2c308be4
- http://www.securityfocus.com/bid/48056/info

* Tue Feb 01 2011 Jacek Konieczny <jajcus@pld-linux.org> bb6f7bb
- mem_debug bcond added

* Sat Nov 13 2010 Jakub Bogusz <qboosh@pld-linux.org> c14cc17
- added version-script patch (fixes missing versioned symbols regression)

* Sat Nov 13 2010 Jakub Bogusz <qboosh@pld-linux.org> df9bb85
- updated to 2.7.8
- updated amfix patch

* Mon Aug 30 2010 Elan Ruusamäe <glen@pld-linux.org> 659b697
- release 4

* Mon Aug 30 2010 Elan Ruusamäe <glen@pld-linux.org> 97e76e0
- fix py for ac

* Thu Jul 08 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 567516f
- release 3

* Sun May 16 2010 sparky <sparky@pld-linux.org> e8966c4
- added TODO: fix build without libxml2-devel
- dropped second BR: zlib-devel

* Sun May 09 2010 Elan Ruusamäe <glen@pld-linux.org> 3ba0dd1
- apidocs bcond

* Sun Apr 04 2010 Jacek Konieczny <jajcus@pld-linux.org> 64256ca
- install egg-info file for the python package

* Wed Mar 17 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 3b59fea
- up to 2.7.7

* Tue Feb 09 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 75ba0ac
- rel 6; don't abuse zlib internal stuff (from archlinux)

* Wed Oct 14 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> b176c2d
- rel 5; force new zlib

* Sat Oct 10 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> 9901ea6
- rel 4; fix largefile brokeness that was manifesting as segfault in zlib related code

* Sat Oct 10 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> b127aea
- release 3

* Fri Oct 09 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> 20a0a8a
- revert crap

* Thu Oct 08 2009 emes <emes@pld-linux.org> 0b339d0
- conditional build with zlib
- zlib disabled on x86_64 due to pointer bug

* Wed Oct 07 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> 1b47bb7
- up to 2.7.6

